--[[
		Define the data used to fill the boxes.
		LoadRawList creates a list of gambits that are level - from the UI - and size appropriate - as defined by the user using the slash command.
		ResetGambitList copies the Raw list to the working copy ready to be changed as the player presses keys.
]]--

--Icons hacked from the game.
SpearIcon="Spear.tga"
ShieldIcon="Shield.tga"
ShoutIcon="Shout.tga"
GambitIcon="Gambit.tga"
BlankIcon="Blank.tga"
icons={SpearIcon,ShieldIcon,ShoutIcon,GambitIcon,BlankIcon}

Player = Turbine.Gameplay.LocalPlayer.GetInstance();

Level = Player:GetLevel();

--Data file containing the info for all the gambits. 
--A lot of this I don't use, but I program here just in case someone wants to use it. All taken from http://lorebook.lotro.com/wiki/Warden:_Gambits_Sorted_By_Effect			

Data={							
{	"HOT",	6,	"216"	,"Persevere",	"Persevere.tga",	"Damage + T1 HoT"	},
{	"HOT",	9,	"237"	,"Impressive Flourish",	"ImpressiveFlourish.tga",	"DoT + T1 HoT"	},
{	"HOT",	17,	"2128"	,"Safeguard",	"Safeguard.tga",	"Damage + T2 HoT"	},
{	"HOT",	37,	"21219"	,"Celebration of Skill",	"CelebrationofSkill.tga",	"Damage + T3 HoT"	},
{	"HOT",	46,	"21212:"	,"Restoration",	"Restoration.tga",	"Damage + T4 HoT"	},
							
							
{	"TOT",	12,	"31;"	,"Precise Blow",	"PreciseBlow.tga",	"Damage + ToT + TI"	},
{	"TOT",	13,	"32<"	,"War Cry",	"WarCry.tga",	"DoT + T1 ToT + T1 HoT; 10 Target"	},
							
							
{	"TT",	16,	"232="	,"Maddening Strike",	"MaddeningStrike.tga",	"Damage + T1 Transfer Fellowship Threat To Warden"	},
{	"TT",	41,	"2323>"	,"Dance of War",	"DanceofWar.tga",	"Evade Bonus + T2 Transfer Fellowship Threat to Warden"	},
{	"TT",	58,	"23232?"	,"Conviction",	"Conviction.tga",	"Fellowship HoT + T2 Transfer Fellowship Threat to Warden"	},
							
							
{	"TI",	4,	"33@"	,"Goad",	"Goad.tga",	"Damage + DoT + TI (4 Target if Traited)"	},
{	"TI",	25,	"313A"	,"Piercing Strike",	"PiercingStrike.tga",	"Damage x2 + T2 Threat"	},
{	"TI",	43,	"3131B"	,"Spear of Virtue",	"SpearofVirtue.tga",	"Damage x2 + TI"	},
							
							
{	"AVOID",	2,	"22C"	,"Defensive Strike",	"DefensiveStrike.tga",	"Damage + Block buff"	},
{	"AVOID",	18,	"213D"	,"Shield Up",	"ShieldUp.tga",	"Block + Evade + Ranged Block buff"	},
{	"AVOID",	32,	"1212E"	,"Wall of Steel",	"WallofSteel.tga",	"Damage x3 + Parry Buff + Interrupt"	},
{	"AVOID",	36,	"2132F"	,"Shield Mastery",	"ShieldMastery.tga",	"Block + Evade + Ranged Block buff T2"	},
{	"AVOID",	41,	"2323G"	,"Dance of War",	"DanceofWar.tga",	"Evade buff + T2 Transfer Fellowship Threat to Warden"	},
							
							
{	"DOT",	1,	"11H"	,"Deft Strike",	"DeftStrike.tga",	"Damage"	},
{	"DOT",	3,	"12I"	,"The Boot",	"TheBoot.tga",	"Damage + Interrupt + Chance to Daze"	},
{	"DOT",	8,	"13J"	,"Offensive Strike",	"OffensiveStrike.tga",	"Damage x2 + TI"	},
{	"DOT",	16,	"123K"	,"Power Attack",	"PowerAttack.tga",	"Damage + T1 DoT"	},
{	"DOT",	19,	"323L"	,"Brink of Victory",	"BrinkofVictory.tga",	"Damage + DoT + ST"	},
{	"DOT",	20,	"131M"	,"Combination Strike",	"CombinationStrike.tga",	"Damage x2 + ST"	},
{	"DOT",	22,	"121N"	,"Onslaught",	"Onslaught.tga",	"Damage x3 + Interrupt"	},
{	"DOT",	30,	"1231O"	,"Mighty Blow",	"MightyBlow.tga",	"Damage + T2 DoT"	},
{	"DOT",	31,	"1313P"	,"Boar's Rush",	"Boar'sRush.tga",	"Damage + Stun on Crit"	},
{	"DOT",	32,	"1212Q"	,"Wall of Steel",	"WallofSteel.tga",	"Damage x3 + Parry Buff + Interrupt"	},
{	"DOT",	38,	"3232R"	,"Surety of Death",	"SuretyofDeath.tga",	"Damage + DoT + T2 Threat"	},
{	"DOT",	43,	"3131S"	,"Spear of Virtue",	"SpearofVirtue.tga",	"Damage x2 + TI"	},
{	"DOT",	50,	"12131T"	,"The Dark Before Dawn",	"TheDarkBeforeDawn.tga",	"Damage + Power Increase when health below 50%"	},
{	"DOT",	52,	"132U"	,"Reversal",	"Reversal.tga",	"Damage + Remove 1 Corruption"	},
{	"DOT",	54,	"1321V"	,"Adroit Manoeuvre",	"AdroitManoeuvre.tga",	"Damage + Attack Speed Buff"	},
{	"DOT",	56,	"32323W"	,"Desolation",	"Desolation.tga",	"DoT + Chance to Fear; 3 targets"	},
{	"DOT",	60,	"13212X"	,"Warden's Triumph",	"Warden'sTriumph.tga",	"Damage + 10% Melee Buff"	},
							
							
{	"MD",	21,	"312Y"	,"Fierce Resolve",	"FierceResolve.tga",	"Morale Drain Over Time; 8 Targets"	},
{	"MD",	42,	"3213Z"	,"Resolution",	"Resolution.tga",	"Direct Morale Drain; 10 Targets"	},
{	"MD",	48,	"31231["	,"Exultation of Battle",	"ExultationofBattle.tga",	"Morale Drain Over Time; 10 Targets"	}}

--Main resource directory location
ResourceDir="JackdawPlugins/WardenIndicator/Resources/"

function LoadRawList()
	--Create the Raw data file, ready to copy later.
	RawGambitList={HOTs={},TOTs={},TTs={},TIs={},Avoids={}, DOTs={},MDs={}}
	local count=0
	for i,k in pairs(Data) do
		if Level>=k[2] then
			if string.len(k[3])>WardenData.minsize then
				count = count +1
				if k[1]=="HOT" then table.insert (RawGambitList.HOTs,k[3]) end
				if k[1]=="TOT" then table.insert (RawGambitList.TOTs,k[3]) end
				if k[1]=="TT" then table.insert (RawGambitList.TTs,k[3]) end
				if k[1]=="TI" then table.insert (RawGambitList.TIs,k[3]) end
				if k[1]=="AVOID" then table.insert (RawGambitList.Avoids,k[3]) end
				if k[1]=="DOT" then table.insert (RawGambitList.DOTs,k[3]) end
				if k[1]=="MD" then table.insert (RawGambitList.MDs,k[3]) end
				
				--[[Testing module
				IconStyle=ResourceDir..IconSize.."/sk_warden_"..k[5]
				Turbine.Shell.WriteLine(IconStyle)
				tester=NewWindow{x=0,y=0,width=20,height=20,colour=Turbine.UI.Color( 0.1, 0, 0,0)}
				tester:SetBackground (IconStyle)]]--
			end
		end
	end
	Turbine.Shell.WriteLine("List of "..count.." gambits loaded, Sir!")
end
	
function ResetGambits()

	GambitList=deepcopy(RawGambitList)

end

--Set wether a gambit is show, or not.
function defaultshow()
	WardenData.showgambit={}
	for i=1,#Data do
		WardenData.showgambit[i]=true
	end
end
