--The main creation function

function CreateFrames()
--Create the main window and set it to watch for key events
	IndiWindow = NewWindow{x=WardenData.x,y=WardenData.y,width=6*IconSize,height=20,colour=Turbine.UI.Color( 0.1, 0, 0,0)}
	IndiWindow:SetMouseVisible(false)
	IndiWindow.DragBar = Deusdictum.UI.DragBar( IndiWindow, "Gambit Indicator")
	IndiWindow.DragBar:SetBarOnTop( not(WardenData.reverse) ) --Bar underneath?
	IndiWindow:SetVisible (false)

	IndiWindow:SetWantsKeyEvents(true);
		IndiWindow.KeyDown = function(sender, args)
			if Player:IsInCombat() or WardenData.showOOC then
				local key=args.Action
				if key==WardenData.spearkey then 
				Update("1")
				end
				if key==WardenData.shieldkey then 
				Update("2")
				end
				if key==WardenData.shoutkey then 
				Update("3")
				end
				if key==WardenData.gambitkey then
				Update("4") -- Gambit!
				end
			else
				if IndiWindow:IsVisible() then
					Update("4")--Send as though a gambit was done to clear the window - we are out of combat, but only if it already isn't visible
				end
			end
		end
		
--Create Box for Gambits
	Main=NewListbox(1024,1)
	Main:SetPosition( 0, 0 )
	Main:SetParent(IndiWindow)
		
--Create the Tooltip Window
	Tooltip={}
	Tooltip.Window=NewWindow{x=0,y=0,width=192,height=60,colour=Turbine.UI.Color( 0.5, 0, 0,0)}
	Tooltip.Window:SetVisible(false)
	
--Create an Overflow message for if the box gets too big...
		overflowlabel=label("Overflow! Too many!",192,Turbine.UI.Color( 0.5, 1, 0,0))
		overflowlabel:SetParent(IndiWindow)
		overflowlabel:SetVisible(false)
		
--If the player wants the frame showing OOC then display it!
	IndiWindow:SetVisible (WardenData.showOOC)
	Display()
--Watch for the player leaving combat and re-set the frame when that happens. When entering combat display the frame. I toyed with reseting, but this can cause problems if you open combat with spear shield or shout instead of javelin.
-- add a callback
handle = AddCallback(Player, "InCombatChanged", function(sender, args )
		if not (Player:IsInCombat()) then
			IndiWindow:SetVisible (WardenData.showOOC)
			ResetGambits()
			Display()
		else
			IndiWindow:SetVisible (true)
			Display()
		end
	end)
end

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

--Update function called when a gambit key is pressed.

		function Update(n)

		--Gambit key pressed. Clear the display and reset the variables
			if n=="4"  then
						IndiWindow:SetVisible (WardenData.showOOC)
						ResetGambits()
						Display()
						return
			end		

			IndiWindow:SetVisible (true)

		--Scan the Gambit List and remove non-compatible gambits.
		for i,k in pairs(GambitList) do
			for j=1, #k do
				if k[j]~=nil then
						if string.sub (k[j],1,1)==n then --If first letter matches then...
							--...trim the rest.
							k[j]=string.sub (k[j],2)
						else
							--Otherwise delete the gambit from the list
							if not(WardenData.fix) then
								--If gambits are "free" then just delete
								k[j]=""
							else
								--However, if positions are fixed then change to just the gambit icon preceded by a space
								if (n=="1" or n=="2" or n=="3") then  k[j]=" "..string.sub (k[j], string.len(k[j]),string.len(k[j])) end
							end
						end
				end
			end
		end

		Display()
		end
		
--Displays the Indicator window by loading the lists into the boxes.
		function Display()
		--Clear the main listbox then add the sub list-boxes.	
		Main:ClearItems() --Nasty hack gone now!

		height=0
		
		GambitBox	(HOT,			"Heal Over Time",		GambitList.HOTs)	
		GambitBox	(AVOID,		"Avoidance",				GambitList.Avoids)
		GambitBox	(DPS,			"DPS",							GambitList.DOTs)
		GambitBox	(MDRAIN,	"Morale Drain",			GambitList.MDs)
		GambitBox	(TOT,			"Threat Over Time",	GambitList.TOTs)
		GambitBox	(TT,				"Threat Transfer",		GambitList.TTs)
		GambitBox	(TI,				"Threat",						GambitList.TIs)
				
		if height==0 then height=WardenData.maxheight/2 end -- sort of a minimum height. Stops a bug caused by the Dragbar.
		--If the frame is bigger than the maximum height then add a warning at the bottom of the box.
			if height>WardenData.maxheight then
				height=WardenData.maxheight
				overflowlabel:SetPosition(0,WardenData.maxheight-16)
				overflowlabel:SetVisible(true)
			else
		--Hide the overflow label
				overflowlabel:SetVisible(false)
			end
		IndiWindow:SetHeight(height) -- Resize the window - may end up being bigger than the screen!
		Main:SetHeight(height) -- Also Resize the main listbox
		if WardenData.reverse then IndiWindow:SetPosition(WardenData.x,WardenData.y-height) else IndiWindow:SetPosition(WardenData.x,WardenData.y) end
		end

--Simple label function
		label=class(Turbine.UI.Label)
		function label:Constructor (text,width,colour)
			if width==nil then width=6*IconSize end
			if colour==nil then colour=Turbine.UI.Color( 0.1,0,0,0 ) end
			Turbine.UI.Label.Constructor(self)
			
			self:SetBackColor( colour );
			if IconSize==32 then self:SetSize( width, 20 ); self:SetFont(Turbine.UI.Lotro.Font.TrajanPro16) else self:SetSize( width, 15 ); self:SetFont(Turbine.UI.Lotro.Font.TrajanPro13) end
			self:SetText( text );
			self:SetMouseVisible (false)
		end

--Simple Listbox function.
		NewListbox= class(Turbine.UI.ListBox)
		function NewListbox:Constructor (height,n)
			Turbine.UI.ListBox.Constructor(self)
			self:SetSize( 6*IconSize, height);
			self:SetMaxItemsPerLine(n)
			self:SetOrientation( Turbine.UI.Orientation.Horizontal);
			self:SetMouseVisible (false)
		end

--Linebreak function; Those pesky columns in Listboxes! Moves to the next line by adding n blank labels.
		function linebreak (target,n,size)
		size=size or IconSize
			for i=1, n do
				target:AddItem(label("",size))
			end
		end

--Icon function; Create an icon from one of the four categories.
		Icon = class( Turbine.UI.Button )		  
		function Icon:Constructor(i)
			local IconStyle
			local index
			Turbine.UI.Button.Constructor( self );
			self :SetSize ( IconSize,IconSize)
			self:SetMouseVisible (false)
			if i~="1" and i~="2" and i~="3" and i~="5" then
				self:SetMouseVisible (true)
				index=string.byte (i)-53
				IconStyle=(ResourceDir..IconSize.."/sk_warden_"..Data[index][5]) -- If the plugin breaks here I have a name wrong!
				--Turbine.Shell.WriteLine(IconStyle)
				
				--Tooltip events
				self.MouseEnter = function(sender,args)
						Tooltip.Cata=nil
						Tooltip.stats=nil
						Tooltip.Cata=label(Data[index][4],192,Turbine.UI.Color( 0.5, 0, 0,0))
							Tooltip.stats=Turbine.UI.Label()
							Tooltip.stats:SetText(Data[index][6])
							Tooltip.stats:SetWidth(192)
							Tooltip.stats:SetBackColor(Turbine.UI.Color( 0.5, 0, 0,0))
							Tooltip.stats:SetFont(Turbine.UI.Lotro.Font.Verdana10)
							Tooltip.stats:SetHeight(40)
						
						Tooltip.Cata:SetParent(Tooltip.Window)
						Tooltip.stats:SetParent(Tooltip.Window)
						
						Tooltip.Cata:SetPosition(0,0)
						Tooltip.stats:SetPosition(0,20)

						Tooltip.Window:SetVisible(true)
					local x,y=Turbine.UI.Display.GetMousePosition()
					local w,h=Turbine.UI.Display.GetSize()
						if x+192>w then x=w-192 end
						if y+60>h then y=h-60 end
						Tooltip.Window:SetPosition(x,y-60)

				end
				
				self.MouseLeave = function(sender,args)
					Tooltip.Window:SetVisible(false)
				end

			else
				IconStyle=ResourceDir..IconSize.."/"..icons[tonumber (i)]
				--Turbine.Shell.WriteLine(IconStyle)
			end
			self:SetBackground (IconStyle)
		end

--Gambit; Takes a list of skills and a target listbox and sends a Gambit there, before linebreaking to the next line of the listbox.
		function Gambit(target,SkillList)
			if SkillList~="" then
				local index=string.byte (string.sub (SkillList, string.len(SkillList),string.len(SkillList)))-53 --This gets the position of the gambit in the overall list.
				if WardenData.showgambit[index] then --If the gambit is to be shown then show it!
					if string.sub (SkillList, 1,1)~=" " then --The space is used when the "fix" feature has been selected
						for i=1, #SkillList do
							target:AddItem(Icon(string.sub (SkillList, i,i)))
						end
						linebreak(target,6-#SkillList)
					else
						--Fix feature
						target:AddItem(Icon("5"))
						linebreak(target,5)
					end
				else
					h=h-1
				end
			end
		end

--AddGambits; Given a target listbox, and a list of gambits, adds them to the listbox!
		function AddGambits (target,List)
			for i=1,#List do
				Gambit(target,List[i])
			end
		end

--Gambit box; Creates a new listbox, named "Target" with label "name" and loads it with the gambits in "List". Calls the functions above.
		function GambitBox(target,name,list)
				h=countlist(list)
				if h~=0 then
					title=label(name)
					if target==nil then target= NewListbox(IconSize,6) else target:ClearItems() end
					AddGambits(target,list)
					target:SetHeight(h*IconSize)
					if h>0 then
						Main:AddItem(title)
						Main:AddItem(target)
						-- add the box height to the overall height of the indiwindow
						if IconSize==32 then height=height+h*IconSize+20 else height=height+h*IconSize+15 end
					end
				end
		end

--countlist; Counts the number of non-empty items in a list. Used to decide the height of the listboxes.
		function countlist(n)
		g=0
		for i=1, #n do
			--if n[i]~=nil then
				if n[i]~="" or WardenData.fix then --If it's empty don't count it BUT do count it if fixed position is required.
					g=g+1
				end
			--end
		end
		return g
		end

		--[[**DeepCopy
		Copies a table - completely and in a "Deep" way.
		And LITERALLY - objects and all.
		I do not pretend to understand the code of this.

		From http://lua-users.org/wiki/CopyTable]]
		function deepcopy(object)
			local lookup_table = {}
			local function _copy(object)
				if type(object) ~= "table" then
					return object
				elseif lookup_table[object] then
					return lookup_table[object]
				end
				local new_table = {}
				lookup_table[object] = new_table
				for index, value in pairs(object) do
						new_table[_copy(index)] = _copy(value)
				end
				return setmetatable(new_table, getmetatable(object))
			end
			return _copy(object)
		end

--Window creator
		NewWindow = class( Turbine.UI.Window )
			function NewWindow:Constructor(options)
				Turbine.UI.Window.Constructor( self )
				self :SetPosition			( options.x,options.y)
				self :SetSize				( options.width,options.height )
				
				self :SetVisible			( options.visible or 1 )
				self :SetOpacity			( options.opacity or 1 )
				self :SetParent			( options.parent or nil)
				if options.mousevisible ~=nil then self :SetMouseVisible	( options.mousevisible) end
				if options.image ~=nil then 	self :SetBackground ( options.image) else self :SetBackColor ( options.colour or Turbine.UI.Color( 1, 0, 0)) end
			end
			
--Key change Function
		function ChangeKeys()
		keypress=0
		Turbine.Shell.WriteLine("Press the 'Spear' key.")
		--Create a temporary window to trap the keys.
		KeyWindow = NewWindow{x=5,y=10,width=30,height=30}

		KeyWindow:SetWantsKeyEvents(true);
			KeyWindow.KeyDown = function(sender, args)
				local key=args.Action
				keypress=keypress+1
					if keypress==1 then
						WardenData.spearkey=key
						Turbine.Shell.WriteLine("Spear set to "..args.Action.." Please press the Shield key.")
					end
					if keypress==2 then 
						WardenData.shieldkey=key
						Turbine.Shell.WriteLine("Shield set to "..args.Action.." Please press the Shout key.")
					end
					if keypress==3 then
						WardenData.shoutkey=key
						Turbine.Shell.WriteLine("Shield set to "..args.Action.." Please press the Gambit key.")
					end
					if keypress==4 then
						WardenData.gambitkey=key
						KeyWindow:SetWantsKeyEvents(false)
						KeyWindow=nil
						Turbine.Shell.WriteLine("Gambit set to "..args.Action.." All keys set, Sir!")
						Save()
					end
			end

		end
		
--Save all settings

function Save()
	WardenData.x,WardenData.y=IndiWindow:GetPosition()
	if WardenData.reverse then WardenData.y=WardenData.y+height end
	Turbine.Shell.WriteLine("All data saved, Sir!")
	Turbine.PluginData.Save( Turbine.DataScope.Character, "WardenIndicator", WardenData )
end

--Change Icon Size
function ChangeSize()
		IconSize=IconSize+8
		if IconSize>32 then IconSize=16 end
		IndiWindow:SetVisible (false)
		IndiWindow=nil
		CreateFrames()
		WardenData.IconSize=IconSize
		Turbine.Shell.WriteLine("Size changed to "..IconSize.." Sir!")
		Display ()
end

function MakeWatcher()
--Create control to watch for the UI being unlocked.
Watcher=Turbine.UI.Control()
Watcher.flag=false
Watcher:SetWantsKeyEvents(true)
	Watcher.KeyDown = function(sender, args)
		if (args.Action == 268435579) then
			if Watcher.flag then Save() end
			Watcher.flag=not(Watcher.flag)
		end
	end
end