import "Turbine"
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "JackdawPlugins.WardenIndicator.Function"
import "JackdawPlugins.WardenIndicator.Data"
import "JackdawPlugins.WardenIndicator.Options"

import "Deusdictum.UI.Dragbar" -- I *love* this plugin!

--Concept; After pressing the initial gambit key, an indicator pops up with suggestions under each major category of gambit skill.

--Many thanks to DeusDictum and the author of http://lorebook.lotro.com/wiki/Warden:_Gambits_Sorted_By_Effect where the tables come from!

--[[Unavoidable Issues; 
		Will not detect if a keypress fails, and will then loop continuously under the wrong indicaton until a gambit is used.
		Cannot be used by clickers, only key-pressers, and ones that use a press to activate gambits too, no less.
		Shows Gambits I do not know, but am the right level for.
		Mouse visibility may be an issue when targeting as a tank; so all frames are mouse-invisible, except... the ability icon *is* mouse visible as otherwise - no tooltips!
		I only have a level 23 Warden and so can't test the high level abilities. Well, not an unavoidable issue, but give me time to level!
		
	Recent Updates:
		Set to show as soon as you enter combat, also set to reset when  you leave combat.
		
	ToDo:

		Key binding module not thoroughly tested.
		Find some way to denote the effects of a gambit better... thinking... thinking...
		Remove Pengoros Callback function -Thanks! - from function.lua and restore all calls to it to old code when Turbine fix the Event bug.
		
	NOTE:
		We have a window, with a listbox. This listbox contains the labels and then sub-listboxes to hold the gambits. The reason there is not just one big listbox is that otherwise the text width messes up.
	]]--

--Greet the Player!
Turbine.Shell.WriteLine("Warden Indicator Here, Sir!")


--Load data
WardenData=Turbine.PluginData.Load( Turbine.DataScope.Character, "WardenIndicator" );
if WardenData==nil then
	WardenData={x=200,y=200,spearkey=268435498,shieldkey=268435506,shoutkey=268435518,gambitkey=268435543,minsize=1,reverse=true,IconSize=32,showOOC=false,maxheight=800,fix=false}
	Turbine.Shell.WriteLine("Welcome to Warden Indicator, Sir! Type /WI for options, Sir!")
end

--If the table for which gambits to show does not exist, then set it to the defaults - all shown.
if WardenData.showgambit==nil then defaultshow() end
if WardenData.maxheight==nil then WardenData.maxheight=800 end

height=WardenData.maxheight/2 --Default Height is half of the maximum height - seems sensible.

IconSize=WardenData.IconSize

--Reset the gambit table.
LoadRawList()
ResetGambits()

--Create all the frames and lets go!
CreateFrames()

--Register to save on Unload

if ( Plugins ["WardenIndicator"] ~= nil ) then
	Plugins["WardenIndicator"].Unload = function( sender, args )
		Save()
		Turbine.Shell.WriteLine("All Warden Indicator data saved, Sir! Many thanks for your kind attention.")
	end
end

--Register to save on UI lock.
MakeWatcher()
