--Register the slash commands

shellCommand = Turbine.ShellCommand()
function shellCommand:Execute(command, args)
	if args=="" then
		Turbine.Shell.WriteLine("Please type '/WI Keys' to change the keys and '/WI *length*' to change the minimum length of gambit to show.")
		Turbine.Shell.WriteLine("'/WI OOC' to toggle if Sir would like the frame showing even when out-of-combat. This allows Sir to practice sequences in one of your many visits to the tavern, Sir.")
		Turbine.Shell.WriteLine("You can also type '/WI all' to show the gambit frame, Sir, but it may be bigger than the screen.")
		Turbine.Shell.WriteLine("'/WI Size' changes the icon size between three possible variants, sir. You may need to reload the plugin due to intermittent Orc Incursion, Sir.")
		Turbine.Shell.WriteLine("'/WI Save' to save settings, Sir.")
		Turbine.Shell.WriteLine("To change the direction of fill type /WI rev. Thank you, Sir!")
		Turbine.Shell.WriteLine("To stop the list condensing the command is /WI fix, Sir.")
		Turbine.Shell.WriteLine("/WI option' to change which gambits are shown in the frame, Sir.")
	end
	
	if args=="option" then
		Display ()
		ShowOption()
	end	
	
	if args=="keys" then 
		ChangeKeys()
	end
	
	if args=="all" then
		Turbine.Shell.WriteLine("Displaying all Gambits of length "..WardenData.minsize.." or more, Sir! May be bigger than the display, Sir! This may disappear any time you press a key, Sir, so try not to be surpised...")
		IndiWindow:SetVisible (true)
		ResetGambits()
		Display()
	end
	
	if args=="rev" then 
		WardenData.reverse=not(WardenData.reverse) 
		Turbine.Shell.WriteLine("Fill direction reversed, Sir. Please remember to relocate the frame.")
		IndiWindow.DragBar:SetBarOnTop( not(WardenData.reverse))
		Display ()
	end
	
	if args=="fix" then
		WardenData.fix=not(WardenData.fix)
		Turbine.Shell.WriteLine("Fix position feature has been toggled, Sir.")
		Display ()
	end	
	
	if args=="ooc" then
		WardenData.showOOC=not(WardenData.showOOC)
		IndiWindow:SetVisible (WardenData.showOOC)
		if WardenData.showOOC then
			Turbine.Shell.WriteLine("Gambits set to show out-of-combat, Sir")
		else
			Turbine.Shell.WriteLine("Gambits set not to show out-of-combat, Sir")
		end
	end
	
	if args=="size" then 
		ChangeSize()
	end
	
	if args=="save" then
		Save()
	end
		
	if type(tonumber(args))=="number" then Turbine.Shell.WriteLine("Minimum gambit length set to "..args) WardenData.minsize=tonumber(args) LoadRawList() ResetGambits()	end
end
Turbine.Shell.AddCommand('WI', shellCommand)

--Options box
--*************

function ShowOption()
--Part 1: Create an option box that will open a given configuration. Worry about editing later.
Option={}

--Make the window	
Option.Window = Turbine.UI.Lotro.GoldWindow();
Option.Window:SetPosition( 100, 100 );

Option.Window:SetText( "Warden Indicator Gambit selection");
Option.Window:SetVisible( true );
Option.Window:SetZOrder(1000)

--Master listbox
--****************
Option.ListBox = Turbine.UI.ListBox();
Option.ListBox:SetParent( Option.Window );
Option.ListBox:SetPosition( 20, 40 );
Option.ListBox:SetSize( 360, 1024); --Height set to silly beyond max, max.
Option.ListBox:SetMaxItemsPerLine(1)
Option.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
Option.MasterTitle=optionlabel(360,"Set Visible Gambits")
Option.MasterTitle:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
Option.MasterTitle:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )

Option.ListBox:AddItem(Option.MasterTitle)
	
	--GambitOption Listbox to hold the gambits.
	--*********************************************
		Option.GambitOption = Turbine.UI.ListBox();
		Option.GambitOption:SetBackColor( Turbine.UI.Color( 0, 0.2, 0.2 ) );
		
		Option.GambitOption:SetMaxItemsPerLine(2)
		Option.GambitOption:SetOrientation( Turbine.UI.Orientation.Horizontal );

		--Which gambits would you like showing?
		Option.Gambit={}
		Option.Gambit.label={}
		local count=0 -- count used to help decide if we are on a new section.
		local bheight=0 --height of the frame
		local currentlabel=""
			for i=1, #Data do
				--Check if we are the right level for the gambit, if not skip the entire thing!
				if Level>=Data[i][2] then
					--First see if we have reached a new section
					if Data[i][1]~=currentlabel then
						--First check if we were on an even numbered line, then do a linebreak if not
						if math.floor(count/ 2) ~= count/2 then Option.GambitOption:AddItem(optionlabel(180,"")) count=count+1 end

						currentlabel=Data[i][1]
						--right, add a new section label then
							Option.GambitOption:AddItem(optionlabel(180,Data[i][1]))
							Option.GambitOption:AddItem(optionlabel(180,""))

						bheight=bheight+20+8*count
						count=0
					end

					Option.Gambit[i]=Turbine.UI.Lotro.CheckBox()
						Option.Gambit[i]:SetChecked(WardenData.showgambit[i])
						Option.Gambit[i]:SetText(Data[i][4])
						Option.Gambit[i]:SetFont(Turbine.UI.Lotro.Font.Verdana10)
						Option.Gambit[i]:SetSize(180,16)
						Option.Gambit[i].CheckedChanged = function( sender, args )
							WardenData.showgambit[i]=not(WardenData.showgambit[i])
							Display()
						end
						Option.GambitOption:AddItem(Option.Gambit[i])
						
					count=count+1 --increase the count
				end
			end
			bheight=bheight+8*(count+1)+20
			
			Option.GambitOption:SetSize( 360, bheight)
			Option.ListBox:AddItem(Option.GambitOption)
	
	--Other Options 
	--***************
		
	Option.SubTitle=optionlabel(360,"Other Options")
	Option.SubTitle:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
	Option.SubTitle:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
		
	Option.ListBox:AddItem(Option.SubTitle)
	
	--Toggle out of combat display
	Option.OOC=Turbine.UI.Lotro.CheckBox()
		Option.OOC:SetChecked(WardenData.showOOC)
		Option.OOC:SetText("Show the frame when Out Of Combat")
		Option.OOC:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
		Option.OOC:SetSize(360,16)
		Option.OOC.CheckedChanged = function( sender, args )
			WardenData.showOOC=not(WardenData.showOOC)
			IndiWindow:SetVisible (WardenData.showOOC)
			Display()
		end
		Option.ListBox:AddItem(Option.OOC)
	
	--Toggle reverse fill
	Option.Rev=Turbine.UI.Lotro.CheckBox()
		Option.Rev:SetChecked(WardenData.reverse)
		Option.Rev:SetText("Reverse Fill")
		Option.Rev:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
		Option.Rev:SetSize(360,16)
		Option.Rev.CheckedChanged = function( sender, args )
			--Try to trap the dragbar problem
			local key= IndiWindow.DragBar:IsVisible()
			
			WardenData.reverse=not(WardenData.reverse)
			WardenData.x,WardenData.y=IndiWindow:GetPosition()
			if WardenData.reverse then WardenData.y=WardenData.y+height end
			IndiWindow.DragBar:SetBarOnTop( not(WardenData.reverse))
			Display ()
			
			if key then
				IndiWindow.DragBar:SetDraggable(true)
			end
		end
		Option.ListBox:AddItem(Option.Rev)
		
	--Toggle fixed position
	Option.Fix=Turbine.UI.Lotro.CheckBox()
		Option.Fix:SetChecked(WardenData.fix)
		Option.Fix:SetText("Free or Fixed Gambits?")
		Option.Fix:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
		Option.Fix:SetSize(360,16)
		Option.Fix.CheckedChanged = function( sender, args )
				WardenData.fix=not(WardenData.fix)
				Display ()
		end
		Option.ListBox:AddItem(Option.Fix)
		
		
		

	--Box for Controls set by Sliders.
	
	Option.FrameBox= Turbine.UI.ListBox();
		Option.FrameBox:SetMaxItemsPerLine(3)
		Option.FrameBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
		Option.FrameBox:SetSize(360,20)
		
	--Change maximum frame height
	Option.FrameBoxLabel=optionlabel(160,"Max. Frame Height ")

	Option.FrameHeight=Turbine.UI.Lotro.ScrollBar()
		Option.FrameHeight:SetSize(150,10)
		Option.FrameHeight:SetMinimum( 200 );
		Option.FrameHeight:SetMaximum( Turbine.UI.Display:GetHeight() );
		Option.FrameHeight:SetValue( WardenData.maxheight );
		Option.FrameHeight:SetOrientation( Turbine.UI.Orientation.Horizontal );
		Option.FrameHeight:SetSmallChange(100)
		Option.FrameHeight:SetLargeChange(200)
		
	Option.FrameBoxVal=optionlabel(50,WardenData.maxheight)
	Option.FrameBoxVal:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
	
	Option.FrameHeight.ValueChanged=function (sender, args)
		WardenData.maxheight=Option.FrameHeight:GetValue()
		Option.FrameBoxVal:SetText(WardenData.maxheight)
		Display()
	end
	
	Option.FrameBox:AddItem(Option.FrameBoxLabel)
	Option.FrameBox:AddItem(Option.FrameHeight)
	Option.FrameBox:AddItem(Option.FrameBoxVal)
	
	Option.ListBox:AddItem(Option.FrameBox)

	--Box for the Three controls done by buttons
	
	Option.ButtonBox= Turbine.UI.ListBox();
		Option.ButtonBox:SetMaxItemsPerLine(2)
		Option.ButtonBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
		Option.ButtonBox:SetSize(360,60)
	
	--Change Keys
	
	Option.Keys = Turbine.UI.Lotro.GoldButton()
		Option.Keys:SetSize(180,30)
		Option.Keys:SetText("Change Keys")
		Option.Keys.Click= function (sender, args)
			ChangeKeys()
		end
	
	Option.ButtonBox:AddItem(Option.Keys)
	
	--Change Icon Size
	Option.Size = Turbine.UI.Lotro.GoldButton()
		Option.Size:SetSize(180,30)
		local IconSize=IconSize+8
		if IconSize>32 then IconSize=16 end
		Option.Size:SetText("Change Size to "..IconSize)
		Option.Size.Click= function (sender, args)
			--Try to trap the dragbar problem
			local key= IndiWindow.DragBar:IsVisible()
			
				ChangeSize()
				local IconSize=IconSize+8
				if IconSize>32 then IconSize=16 end
				Option.Size:SetText("Change Size to "..IconSize)
				
			if key then
				IndiWindow.DragBar:SetDraggable(true)
			end
		end
		
		Option.ButtonBox:AddItem(Option.Size)
		
	--Change Gambit Length
	Option.GambitLen=Turbine.UI.Lotro.Button()
		Option.GambitLen:SetSize(180,30)
		local len=WardenData.minsize+1
		if len>5 then len=1 end
		Option.GambitLen:SetText("Change Min Len to "..len)
		
		Option.GambitLen.Click= function (sender, args)
			WardenData.minsize=len
				len=WardenData.minsize+1
				if len>5 then len=1 end
				Option.GambitLen:SetText("Change Min Len to "..len)
			LoadRawList()
			ResetGambits()
			Display()
		end
		
	Option.ButtonBox:AddItem(Option.GambitLen)
		
	Option.ListBox:AddItem(Option.ButtonBox)
	
	
	Option.Window:SetSize( 400,  200+ Option.GambitOption:GetHeight())
	
	--Register all settings to save when the frame is closed, and the option window to be deleted.
	Option.Window.Closed = function( sender, args )
		Save()
		Option=nil
	end
	
end

 
 optionlabel=class(Turbine.UI.Label)
 function optionlabel:Constructor(width,text)
	Turbine.UI.Label.Constructor(self)
	self:SetSize( width, 20 );
	self:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
	self:SetText( text);
end

optiontextbox=class(Turbine.UI.Lotro.TextBox)
function optiontextbox:Constructor(width,text)
	Turbine.UI.Lotro.TextBox.Constructor(self)
	self:SetSize(width,30)
	self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self:SetFont(Turbine.UI.Lotro.Font.Verdana23)
	self:SetText(text)
end
